"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RandomBitIterator = void 0;
const BytesToBitIterator_1 = require("./BytesToBitIterator");
const PseudoRandom_1 = require("./PseudoRandom");
class RandomBitIterator {
    pseudoRandom;
    bitIterator;
    constructor(seed) {
        this.pseudoRandom = new PseudoRandom_1.PseudoRandom(seed);
        this.bitIterator = new BytesToBitIterator_1.BytesToBitIterator(Uint8Array.from([this.pseudoRandom.randomByte()]));
    }
    next() {
        let bitResult = this.bitIterator.next();
        while (bitResult.done ?? false) {
            this.bitIterator = new BytesToBitIterator_1.BytesToBitIterator(Uint8Array.from([this.pseudoRandom.randomByte()]));
            bitResult = this.bitIterator.next();
        }
        return { value: bitResult.value };
    }
}
exports.RandomBitIterator = RandomBitIterator;
