"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebsiteFetcher = void 0;
const cross_fetch_1 = __importDefault(require("cross-fetch"));
const dom_parser_1 = __importDefault(require("dom-parser"));
const HtmlNode_1 = require("./HtmlNode");
class WebsiteFetcher {
    url;
    constructor(url) {
        this.url = url;
    }
    async fetch() {
        const data = await (0, cross_fetch_1.default)(this.url);
        const html = await data.text();
        const dom = new dom_parser_1.default().parseFromString(html);
        return new HtmlNode_1.HtmlDom(dom);
    }
}
exports.WebsiteFetcher = WebsiteFetcher;
